#ifndef PURIFY_CPP_CONFIG_H
#define PURIFY_CPP_CONFIG_H

//! Problems with using and constructors
/* #undef PURIFY_HAS_USING */
#ifndef PURIFY_HAS_USING
#define PURIFY_HAS_NOT_USING
#endif

//! Whether to do logging or not
#define PURIFY_DO_LOGGING

//! Whether to do openmp
#define PURIFY_OPENMP

#include <string>
#include <tuple>

namespace purify {
//! Returns library version
inline std::string version() { return "2.0.0"; }
//! Returns library version
inline std::tuple<uint8_t, uint8_t, uint8_t> version_tuple() {
  // clang-format off
  return std::tuple<uint8_t, uint8_t, uint8_t>(
      2, 0, 0);
  // clang-format on
}
//! Returns library git reference, if known
inline std::string gitref() { return ""; }
//! Default logging level
inline std::string default_logging_level() { return "critical"; }
//! Default logger name
inline std::string default_logger_name() { return "purify"; }
//! Wether to add color to the logger
inline constexpr bool color_logger() {
  // clang-format off
  return true;
  // clang-format on
}
}

#endif
